<?php
if ( !defined( 'ABSPATH' ) ) exit; 
if (!isset($_REQUEST['click_data']) || empty($_REQUEST['click_data'])) {
    die('No data to export!');
    exit;
};
$data = sanitize_text_field($_REQUEST['click_data']);
$clicks_data = sanitize_text_field(stripslashes($_REQUEST['click_data']));
$clicks = json_decode($clicks_data);
srpd_generate_csv($clicks);

function srpd_generate_csv($clicks) {
    header('Content-Type: text/csv; charset=utf-8');
    header('Content-Disposition: attachment; filename=keyword.stats.csv');
    header("Pragma: no-cache");
    header("Expires: 0");
    $output = fopen('php://output', 'w');
    fputcsv($output, array(
        'Clicks for the last 24 hours'
    ));

    fputcsv($output, array(
        'No.',
        'Visit Time',
        'Referrer',
        'User Agent',
        'Traffic Location',
            ), ';');
    $i = 1;
    foreach ($clicks as $click) {
        fputcsv($output, array(
            $i++ . ".",
            date("H:i:s d/m/Y", strtotime($click->click_time)),
            $click->referrer,
            $click->user_agent,
            $click->country_code,
                ), ';');
    };

    fclose($output);
}
?>