<?php
include 'input.php';
?>
<div class="wrap">
    <h2>Add Link Project</h2>
    <p>Here is where you can create link projects to auto-hyperlink keywords in your posts and/or pages. The plugin will automatically add the links for you. Don't forget to click the 'Create Link Project' button before exiting.</p>
    <?php
    if (isset($_POST['project_name']) && !empty($_POST['project_name'])) {
        if(!wp_verify_nonce( $_POST['_wpnonce'], 'icp-linkpro-852' )){
             echo '<script type="text/javascript"> window.location = \'' . admin_url('admin.php?page=icp_link_projects') . '\'; </script>';
             die();
        }
        global $wpdb;
        $links = explode(",", ltrim($_POST['links'], ','));
        foreach ($links as $key => $link) {
            if (!empty($link)) {
                $link = trim($link);
                $links[$key] = (strpos($link, 'http://') === false && strpos($link, 'https://') === false) ? 'http://' . $link : $link;
            } else {
                unset($links[$key]);
            }
        };
        if (count($links) > 0) {
            //$keywords = explode( ",", ltrim($_POST['keywords'], ',' ) );
            $table_name = $wpdb->prefix . "icp_projects";
            $ignores = (!empty($_POST['ignores'])) ? sanitize_text_field($_POST['ignores']) : '';
            $ignores = explode("\n", $ignores);
            $tmp = "";
            foreach ($ignores as $ig) {
                $ig = trim($ig);
                $tmp .= $ig . ",";
            };
            $ignores = rtrim($tmp, ",");
            $wpdb->insert($table_name, array(
                'project_name' => sanitize_text_field($_POST['project_name']),
                'posts' => ( $_POST['hyperlink_posts'] == 'on' ) ? 1 : 0,
                'pages' => ( $_POST['hyperlink_pages'] == 'on' ) ? 1 : 0,
                'existing' => ( $_POST['hyperlink_existing'] == 'on' ) ? 1 : 0,
                'new' => ( $_POST['hyperlink_new'] == 'on' ) ? 1 : 0,
                'comments' => ( $_POST['comments'] == 'on' ) ? 1 : 0,
                'new_window' => ( $_POST['new_window'] == 'on' ) ? 1 : 0,
                'headings' => ( $_POST['headings'] == 'on' ) ? 1 : 0,
                'max_replace' => (!empty($_POST['max_replace'])) ? sanitize_text_field($_POST['max_replace']) : 3,
                'max_keyword' => (!empty($_POST['max_keyword'])) ? sanitize_text_field($_POST['max_keyword']) : 1,
                'no_follow_weight' => (!empty($_POST['no_follow_weight'])) ? trim(sanitize_text_field($_POST['no_follow_weight']), "%") : 0,
                'ignores' => $ignores,
                'created_at' => time()
                    ), array('%s', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%d', '%s', '%d'));
            $pId = $wpdb->insert_id;
            $keywords = explode("\n", $_POST['keywords']);
            foreach ($keywords as $keyword) {
                $keyword = trim($keyword);
                $wpdb->insert($wpdb->prefix . "icp_project_keywords", array('id_project_fk' => $pId, 'keyword' => sanitize_text_field($keyword)), array('%d', '%s'));
            };
            foreach ($links as $link) {
                $wpdb->insert($wpdb->prefix . "icp_project_links", array('id_project_fk' => $pId, 'url' => sanitize_text_field($link)), array('%d', '%s'));
            };
#### HYPERLINK EXISTING CONTENT - BEGIN ####
            $query = "SELECT * FROM " . $wpdb->prefix . "posts WHERE post_type = 'post' OR post_type = 'page'";
            $posts = $wpdb->get_results($query, OBJECT);

            $query = "SELECT * FROM " . $wpdb->prefix . "icp_projects WHERE id = " . $pId;

            $project = $wpdb->get_row($query);

            $exclude = explode(",", $project->ignores);

            foreach ($exclude as $key => $ex) {

                $exclude[$key] = trim($ex);
            };
            foreach ($posts as $post) {
                if (!in_array($post->ID, $exclude) && !in_array($post->post_name, $exclude)) {
                    if ($project->existing == 1) {
                        $comments = $wpdb->get_results("SELECT * FROM " . $wpdb->prefix . "comments WHERE comment_post_ID = " . $post->ID);
                        if ($project->posts == 1 && $post->post_type == 'post') {
                            echo "inside content";
                            srpd_content_helper($project, $post->post_content, $post->ID, 'content');
                            //
                            if ($project->headings == 1)
                                echo "inside title";
                            srpd_content_helper($project, $post->post_title, $post->ID, 'title');
                            //						
                            if ($project->comments == 1) {
                                foreach ($comments as $comment) {
                                    srpd_content_helper($project, $comment->comment_content, $post->ID, 'comment');
                                }
                            };
                        };
                        if ($project->pages == 1 && $post->post_type == 'page') {
                            srpd_content_helper($project, $post->post_content, $post->ID, 'content');
                            //
                            if ($project->headings == 1)
                                srpd_content_helper($project, $post->post_title, $post->ID, 'title');
                            //			
                            if ($project->comments == 1) {
                                foreach ($comments as $comment) {
                                    srpd_content_helper($project, $comment->comment_content, $post->ID, 'comment');
                                }
                            };
                        };
                    };
                };
            };
#### HYPERLINK EXISTING CONTENT - END ####
            echo '<div id="message" class="updated"><p>Link Project added successfully.</p></div>';
            $message = urlencode("Link Project added successfully.");
            echo '<script type="text/javascript"> window.location = \'' . admin_url('admin.php?page=icp_link_projects&type=updated&message=' . $message) . '\'; </script>';
            die();
        } else {
            echo '<div id="message" class="error"><p>Please enter valid URLs for the links.</p></div>';
        };
    } elseif (isset($_POST['project_name']) && empty($_POST['project_name'])) {
        echo '<div id="message" class="error"><p>The Project Name is required.</p></div>';
    };
    ?>
    <form method="post" action="" id="add_form">
        <input type="hidden" name="_wpnonce" value="<?=wp_create_nonce('icp-linkpro-852')?>">
        <table class="form-table" >
            <tr class="form-field" >
                <td width="200px" >
                    <label for="project_name" >Project Name:</label>
                </td>
                <td>
                    <input type="text" name="project_name" id="project_name" class="" style="width: 50%;height: 30px;" />
                </td>
            </tr>
            <tr>
                <td width="200px" >
                    <label for="auto_hyperlink" >Auto-hyperlink:</label>
                </td>
                <td>	
                    <input type="checkbox" name="hyperlink_posts" id="hyperlink_posts" /> Posts 
                    <input type="checkbox" name="hyperlink_pages" id="hyperlink_pages" style="margin-left: 30px;"/> Pages
                </td>
            </tr>
            <tr>
                <td width="200px" >
                    <label for="auto_hyperlink" >Content to auto-hyperlink:</label>
                </td>
                <td>	
                    <input type="checkbox" name="hyperlink_existing" id="hyperlink_existing" /> Existing content 
                    <input type="checkbox" name="hyperlink_new" id="hyperlink_new" style="margin-left: 30px;"/> New content
                </td>
            </tr>
            <tr>
                <td>
                    <label>Replace keywords in Comments</label>
                </td>
                <td>
                    <input type="checkbox" name="comments" id="comments" />
                </td>
            </tr>
            <tr>
                <td>
                    <label>Open links in new tab</label>
                </td>
                <td>
                    <input type="checkbox" name="new_window" id="new_window" />
                </td>
            </tr>
            <tr>
                <td>
                    <label>Hyperlink titles & headings of Posts & Pages</label>
                </td>
                <td>
                    <input type="checkbox" name="headings" id="headings" />
                </td>
            </tr>
            <tr>
                <td>
                    <label> Maximum hyperlink replacements per Post or Page</label>
                </td>
                <td>
                    <select name="max_replace" id="max_replace" style="width:110px;">      
                        <option value="1" selected="selected">1</option>
                        <option value="2">2</option>
                        <option value="3">3</option>
                        <option value="4">4</option>
                        <option value="5">5</option>   
                    </select>
                </td>
            </tr>
            <tr>
                <td>
                    <label>Maximum hyperlink replacements per keyword on this site (sitewide)</label></td>
                <td>
                    <select name="max_keyword" id="max_keyword" style="width:110px;">      
                        <option value="1" >1</option>
                        <option value="2" >2</option>
                        <option value="3" selected="selected">3</option>
                        <option value="4" >4</option>
                        <option value="5" >5</option>   

                        <option value="6" >6</option>
                        <option value="7" >7</option>
                        <option value="8" >8</option>
                        <option value="9" >9</option>
                        <option value="10" >10</option>   

                        <option value="11">11</option>
                        <option value="12">12</option>
                        <option value="13">13</option>
                        <option value="14">14</option>
                        <option value="15">15</option>   

                        <option value="16">16</option>
                        <option value="17">17</option>
                        <option value="18">18</option>
                        <option value="19">19</option>
                        <option value="20">20</option>   
                    </select>
                </td>
            </tr>
            <tr>
                <td>
                    <label>Weight of no-follow links on this site (sitewide)</label></td>
                <td>
                    <select name="no_follow_weight" id="no_follow_weight" style="width:110px;">      
                        <option value="0" selected="selected">0</option>
                        <option value="10" >10</option>
                        <option value="20" >20</option>
                        <option value="25" >25</option>
                        <option value="30" >30</option>
                        <option value="40" >40</option>
                        <option value="50" >50</option>
                        <option value="60" >60</option>
                        <option value="70" >70</option>
                        <option value="75" >75</option>
                        <option value="80" >80</option>
                        <option value="90" >90</option>
                        <option value="100" >100</option>
                    </select> %
                </td>
            </tr>
            <tr>
                <td>
                    <label>Ignore Pages & Posts (1 Post or Page ID per line)</label>
                </td>
                <td>
                    <textarea rows="3" cols="20" name="ignores" id="ignores" style="width: 50%"></textarea>
                </td>
            </tr>
            <tr>
                <td>
                    <label>Keywords (1 keyword per line)</label>
                </td>
                <td>
                    <textarea id="keywords" name="keywords" rows="5" cols="20" style="width: 50%"></textarea>
                </td>
            </tr>
            <tr>
                <td>
                    <label>Links (1 URL per line)</label>
                </td>
                <td>
                    <textarea id="links" name="links" rows="5" cols="20" style="width: 50%"></textarea>
                </td>
            </tr>
            <tr>
                <td colspan="2">
                    <p class="submit" >
                        <input type="submit" name="submit" value="Create Link Project" /> &nbsp;or&nbsp; <a href="<?php echo admin_url('admin.php?page=icp_link_projects'); ?>" >Cancel</a>
                    </p>
                </td>
            </tr>
        </table>
    </form>
</div>