<?php
if ( !defined( 'ABSPATH' ) ) exit; 
if (isset($_POST['plugin_key'])) {
    if(wp_verify_nonce( $_POST['_wpnonce'], 'icp-pluginkey-852' )){
        $res = srpd_update_plugin_key();
        if ($res == '1')
            $msg = '<div id="icp_closeNotification" class="icp_successMsg">Your changes have been successfully saved.</div>';
        else
            $msg = '<div id="icp_closeNotification" class="icp_errorMsg">' . $res . '</div>';
    } else {
        $msg = '<div id="icp_closeNotification" class="icp_errorMsg">Invalid Request</div>';
    }
};
if (isset($_POST['clickbank_id'])) {
    if (filter_var($_POST['clickbank_id'], FILTER_VALIDATE_URL)) {
        $msg = '<div id="icp_closeNotification" class="icp_errorMsg">Please don\'t enter a URL in this field. Simply enter your ClickBank username instead.</div>';
    } else {
    if(wp_verify_nonce( $_POST['_wpnonce'], 'icp-clickbank-852' )){
        $res = srpd_update_clickbank_id();
        if ($res == '1')
            $msg = '<div id="icp_closeNotification" class="icp_successMsg">Your changes have been successfully saved.</div>';
        else
            $msg = '<div id="icp_closeNotification" class="icp_errorMsg">' . $res . '</div>';
    } else {
        $msg = '<div id="icp_closeNotification" class="icp_errorMsg">Invalid Request</div>';
    }
}
}
if (isset($_POST['autoUpdateBtn'])) {
    if(wp_verify_nonce( $_POST['_wpnonce'], 'icp-autoUpdate-852' )){
        if (isset($_POST['icp_wp_auto_update']))
            update_option('icp_wp_auto_update', 'true');
        else
            update_option('icp_wp_auto_update', '');

        if (isset($_POST['icp_plugins_auto_update']))
            update_option('icp_plugins_auto_update', 'true');
        else
            update_option('icp_plugins_auto_update', '');

        if (isset($_POST['icp_themes_auto_update']))
            update_option('icp_themes_auto_update', 'true');
        else
            update_option('icp_themes_auto_update', '');
    }
}
$access = 1;
include 'input.php';
$icp_wp_auto_update = (get_option('icp_wp_auto_update') == '') ? false : true;
$icp_plugins_auto_update = (get_option('icp_plugins_auto_update') == '') ? false : true;
$icp_themes_auto_update = (get_option('icp_themes_auto_update') == '') ? false : true;
?>
<table width="100%" border="0" cellspacing="0" cellpadding="3">
    <tr>
        <td width="30"><img src="<?= srpd_root_path() ?>img/settings.png" width="30" height="30" /></td>
        <td><h1>Settings</h1></td>
    </tr>
</table>
<?php
if (isset($msg)) {
    echo $msg;
    ?>
    <script type="text/javascript">
        var $ = jQuery.noConflict();
        $(document).ready(function () {
            setTimeout(function () {
                $('#icp_closeNotification').fadeOut();
            }, 5000);
        });
    </script>
<?php } ?>
<div id="icp_content">
    <?php if ($user['status'] == 'active') { ?>
        <p>Your Plugin Key:</p>
    <?php } else { ?>
        <p>Please Enter Your Plugin Key:</p>
    <?php } ?>
    <form id="form1" name="form1" method="post" action="">
        <input type="hidden" name="_wpnonce" value="<?=wp_create_nonce('icp-pluginkey-852')?>">
        <label for="plugin_key"></label>
        <input type="text" name="plugin_key" id="plugin_key" style="width:500px;" value="<?= esc_html(srpd_get_plugin_key()) ?>" />
        <input type="submit" name="button" id="button" class="button" value="Save" /><br />
        <span style="font-size:12px;">You can find your plugin key <a href="https://members.serped.net/profile.php?mod=plugins" target="_blank">here.</a></span>
    </form>

    <?php if ($user['status'] == 'active') { ?>
        <br />
        <table width="100%" border="0" cellspacing="0" cellpadding="3">
            <tr>
                <td width="90" valign="top">
                    <?php
                    if (strlen($user['profile_image']) > 0) {
                        $img_url = urldecode($user['main_url']) . '/images_v2/profile_images/' . $user['profile_image'];
                    } else {
                        $default = urldecode($user['main_url']) . "/images_v2/profile_img.png";
                        $size = 80;
                        $img_url = "https://www.gravatar.com/avatar/" . md5(strtolower(trim($user['email']))) . "?d=" . urlencode($default) . "&s=" . $size;
                    }
                    ?><img src="<?= $img_url ?>" width="80" height="80" class="round" style="border:3px #f4f4f4 solid;" title="<?= $user['first_name'] ?>" />
                </td>
                <td valign="top"><h2 style="margin-bottom:5px; padding-bottom:5px;">Welcome <?= $user['first_name'] . ' ' . $user['last_name'] ?></h2>
                    <strong>Email: </strong><?= $user['email'] ?><br />
                    <a href="<?= urldecode($user['main_url']) . '/login.php' ?>" target="_blank">Login to your account</a>
                </td>
            </tr>
        </table>
        <br />
        <h2><strong>ClickBank ID:</strong></h2>
        <form id="form2" name="form2" method="post" action="">
            <label for="clickbank_id"></label>
            <input type="hidden" name="_wpnonce" value="<?=wp_create_nonce('icp-clickbank-852')?>">
            
            <input type="text" name="clickbank_id" id="clickbank_id" style="width:500px;" value="<?= esc_html(srpd_get_clickbank_id()) ?>" placeholder="Please Enter Your ClickBank ID (optional)"/>
            <p>Add your ClickBank ID to turn the link to SERPed.net in the widget footer into an affiliate link and earn a commission for every referred sale (optional).</p>
            <p><input type="submit" name="button" id="button" value="Save Changes" class="button" /></p>
        </form>
        <br />
        <h1>Auto Update Settings:</h1>
        <p>Here is where you can automate the update of WordPress, your plugins and themes.</p>
        <form id="form1" name="form1" method="post" action="">
            <input type="hidden" name="_wpnonce" value="<?=wp_create_nonce('icp-autoUpdate-852')?>">
            <table class="widefat fixed" cellspacing="0">
                <thead>
                    <tr>
                        <th id="cb" class="manage-column column-cb check-column" scope="col" style="width:10%; text-align:center"></th>
                        <th id="columnname" class="manage-column column-columnname" scope="col">Option</th>
                    </tr>
                </thead>
                <tbody>

                    <tr class="alternate">
                        <th class="check-column" scope="row" style=" text-align:center">
                            <input type="checkbox" name="icp_wp_auto_update" <?php if ($icp_wp_auto_update) echo 'checked'; ?>  />
                        </th>
                        <td class="column-columnname">
                            <strong>Auto Update WordPress Version</strong>
                            <p>To make sure your WordPress version is always up-to-date, for better security. Highly recommended!</p>
                        </td>
                    </tr>
                    <tr class="alternate">
                        <th class="check-column" scope="row"  style=" text-align:center">
                            <input type="checkbox" name="icp_plugins_auto_update" <?php if ($icp_plugins_auto_update) echo 'checked'; ?>  />
                        </th>
                        <td class="column-columnname">
                            <strong>Auto Update All Plugins</strong>
                            <p>To make sure your plugins are always up-to-date, for better security. The only downside is that there is a chance an active plugin is incompatible with your WordPress version and causes issues.</p>
                        </td>
                    </tr>
                    <tr class="alternate">
                        <th class="check-column" scope="row"  style=" text-align:center">
                            <input type="checkbox" name="icp_themes_auto_update" <?php if ($icp_themes_auto_update) echo 'checked'; ?>  />
                        </th>
                        <td class="column-columnname">
                            <strong>Auto Update All Themes</strong>
                            <p>To make sure your themes are always up-to-date, for better security. The only downside is that there is a chance your active theme is incompatible with your WordPress version and causes issues.</p>
                        </td>
                    </tr>
                </tbody>
            </table>
            <p><input type="submit" name="autoUpdateBtn" id="button" value="Save Changes" class="button" /></p>
        </form>
        <br />
        <h1>Video Tutorial</h1>
        <p>Please watch this video before you start using the plugin:</p>
        <p><iframe src="//player.vimeo.com/video/371132422" width="500" height="281" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe></p>
        <p>You will find more training as well as updates on our <a href="https://www.serped.com/" target="_blank">blog</a>. 
            We regularly publish new content (product updates, training...) so it is important to check it from time to time.</p>
    <?php } ?>
</div>